@import (once) "grid";

@screen-extra-large:  elg; @screen-extra-large-threshold: 1500px;

@screen-large:  lg; @screen-large-threshold: 950px;
@screen-medium: md; @screen-medium-threshold: 600px;
@screen-small:  sm; @screen-small-threshold: 480px;

// Visual Controls
@media (max-width: (@screen-extra-large-threshold - 1)) {
  .hide-@{screen-extra-large} {display: none !important;};
  #post-office {
    backdrop-filter: none !important; padding: 0 !important;
    #post-office-box {
      width: 100% !important; left: 0 !important; margin-left: 0 !important; top: 0 !important;
      bottom: 0 !important; border-radius: 0 !important;
    }
  }
}
@media (min-width: @screen-large-threshold) {
  .hide-desktop {display: none !important;};
}
@media (max-width: (@screen-large-threshold - 1)) {
  .hide-mobile {display: none !important;};
  body {background: black;}
  #wrapper, div.game-menu-area, footer { width: 100%; }
  #wrapper.attract > #header .attract_button { background-image: url("../img/background/bg_attract_button_detached.png") }
  div.town-header {
    &:before { display: none; }
    &.hardcore {
      &:before { display: none; }
    }
    position: relative; margin-bottom: 5px; padding-bottom: 5px; border-bottom: 2px solid rgba(0,0,0,0.25);
    &>b { display: block; position: relative; left: 0; top: 0; width: 100%; color: @myhordes-smalltext }
    &>span { position: relative; display: block; left: 0; top: 0; width: 100%; color: black; }
  }

  div.game-menu-area > div.game-bar > ul.text-menu > li.poll-dash {
    left: calc( 100vw - 240px );
  }

  #gazette {
    perspective: 1000px;
    width: 95%;
    height: 0;
    padding-bottom: 75%;

    .newspage {
      width: 90%; height: 0; margin: 0; display: block; vertical-align: top; position: absolute; padding-bottom: 75%;
      background-size: cover; transform-style: preserve-3d; transition: transform 1.0s ease-in-out, opacity 0s 0.5s;
      backface-visibility: visible; left: 5%; z-index: 0;

      &#newspage-front {
        margin-left: 0; opacity: 1;
        div#gazette-content { font-size: 2.5vw; max-height: 35.5%; }
        div#gazette-headline { font-size: 3.2vw; top: 13%; }
        div#gazette-signature { font-size: 2.5vw; }
        div#gazette-deaths { font-size: 3vw; }
      }
      &#newspage-back {
        width: 90%; margin-left: 0; transform: rotateY(-180deg); z-index: 1; opacity: 0; pointer-events: none;
        .nightstat { font-size: 3vw; }
        #buildingdetails { top: 55%; }
      }
    }
  }
  #gazette-switcher { display: block; margin: auto; padding: 1rem; }
  #gazette-switch:checked + #gazette {
    .newspage {
      transform: rotateY(-180deg);
      &#newspage-front { opacity: 0; pointer-events: none }
      &#newspage-back { transform: rotateY(-360deg); opacity: 1 }
    }
  }

  .gazette-search {
    margin-left: 10px !important;
    h2 {
      overflow: hidden;
    }
  }
}
@media (max-width: (@screen-large-threshold - 1)) and (min-width: @screen-small-threshold) {
  .row > .cell.town-addons {
    flex-wrap: wrap;
    & > .town-addon {
      flex-basis: 30%;
      width: 30%;
      height: auto;

      & > div {
        height: 0;
        width: 100%;
        padding-bottom: 100%;
      }
    }
  }
  .row > .cell.town-addons > .town-addon.town-addon-empty > div {
    display: none;
  }
}
@media (max-width: (@screen-large-threshold - 1)) and (min-width: @screen-medium-threshold) {
  .hide-@{screen-large} {display: none !important;};
  .dashboard .def-estimation { border-right: none; }
  .soul .language-picker {
    flex-wrap: wrap;
    &>.note {
      width: 50%;
      flex-basis: 50%;
    }
  }
  .forum-preview-wrapper {
    max-height: 360px;
    &.forum-preview-wrapper-bank {
      min-height: 360px;
    }
  }
}
@media (max-width: (@screen-medium-threshold - 1)) and (min-width: @screen-small-threshold) {
  .hide-@{screen-medium} {display: none !important;};
  .dashboard .attack-estimation, .dashboard .def-estimation { border-right: none; }
  .soul .language-picker {
    flex-wrap: wrap;
    &>.note {
      width: 100%;
      flex-basis: 100%;
    }
  }
  ul.actions>li, ul.special_actions>li, ul.heroic_actions>li {
    &>div.targets { left: 0; right: 0; top: 100%; }
  }
  .forum-preview-wrapper {
    max-height: 180px;
    &.forum-preview-wrapper-bank {
      min-height: 180px;
    }
  }
  h4.preview-header { width: 100%; left: 0; padding: 4px; }

  .soul .view-rp {
    .postit, .tinystamp { margin-left: -80px; }
    .money { margin-left: -40px; }
  }
}
@media (max-width: (@screen-small-threshold - 1)) {
  .hide-@{screen-small} {display: none !important;};
  #notifications { width: 100%; left: 0; margin-left: 0; }
  #postbox {
    img { height: 32px; width: 32px; }
    #postbox-new-msg-counter {
      position: absolute; background: darkred; padding: 2px; border-radius: 100px; bottom: -2px; right: -2px;
      display: block; width: 24px; height: 24px; font-size: 14px; text-align: center; box-shadow: 0 0 3px black;
    }
  }
  #wrapper > #content #apps #apps-list ul li.app-external { width: 100% !important; }
  button:not(.no-mobile-resize), .button:not(.no-mobile-resize) { padding-top: 16px; padding-bottom: 16px; margin-top: 8px; margin-bottom: 8px; }

  h4.preview-header { width: 100%; left: 0; padding: 4px; }
  .about-paragraph img { max-width: 100%; width: 100% }

  .rucksack_status_union.rucksack {
    &:before {
      left: 0 !important;
      background: url("../img/game-bar/panel_tl.png") 0 0 no-repeat,url("../img/game-bar/panel_bl.png") 0 100% no-repeat,url("../img/game-bar/panel_l.png") 0 0 repeat-y !important;
    };
  }

  .soul .news .content {
    padding: 5px; background: #5c2b20; min-height: auto;
  }

  .soul .view-rp {
    .postit, .tinystamp { margin-left: -135px; }
    .money { margin-left: -66px; }
  }

  body:not(.icon-zoom-1-00) ul.inventory {
    &.rucksack { background: url("../img/background/inventory/inv_bag.gif") no-repeat top left/cover;  }
    & > li {
      &.title { margin: 5px; display: inline-flex; align-items: center }
      &:not(.title):not(.category) {
        margin: 5px; text-align: center;
        &.item.counted {
          position: relative;
          & > span:not(:first-child) {
            background: rgba(0,0,0,0.75); padding: 1px 3px; border-radius: 2px; position: absolute; right: -5px; bottom: -5px;
          }
        }
        &.item img { image-rendering: pixelated }
      }
    }
  }

  body.icon-zoom-1-25 ul.inventory > li {
    &.title { height: 22px !important; }
    &:not(.title):not(.category) {
      height: 22px !important;  width: 22px !important;
      &.item img { width: auto; height: 20px; }
    }
  }
  body.icon-zoom-1-50 ul.inventory > li {
    &.title { height: 26px !important; }
    &:not(.title):not(.category) {
      height: 26px !important;  width: 26px !important;
      &.item img { width: auto; height: 24px; }
    }
  }
  body.icon-zoom-1-75 ul.inventory > li {
    &.title { height: 30px !important; }
    &:not(.title):not(.category) {
      height: 30px !important;  width: 30px !important;
      &.item img { width: auto; height: 28px; }
    }
  }
  body.icon-zoom-2-00 ul.inventory > li {
    &.title { height: 34px !important; }
    &:not(.title):not(.category) {
      height: 34px !important;  width: 34px !important;
      &.item img { width: auto; height: 32px; }
    }
  }

  ul.actions>li, ul.special_actions>li, ul.heroic_actions>li {
    padding-top: 16px; padding-bottom: 16px; &>img:first-child { top: 19px; }
    &>div.targets {
      left: 0; right: 0; top: 100%;
      &>ul>li:not(.line) { padding: 16px; margin: 8px; }
      & *[x-close-for] { display: inline-block; padding: 16px; }
    }
  }

  body:not(.icon-zoom-1-00) {
    ul.actions>li, ul.special_actions>li, ul.heroic_actions>li {
      &>div.targets>ul>li img { image-rendering: pixelated }
    }
  }

  body.icon-zoom-1-25 {
    ul.actions>li, ul.special_actions>li, ul.heroic_actions>li {
      &>div.targets>ul>li {
        padding: 12px;
        img { width: auto; height: 20px; }
      }
    }
  }

  body.icon-zoom-1-50 {
    ul.actions>li, ul.special_actions>li, ul.heroic_actions>li {
      &>div.targets>ul>li {
        padding: 8px;
        img { width: auto; height: 24px; }
      }
    }
  }

  body.icon-zoom-1-75 {
    ul.actions>li, ul.special_actions>li, ul.heroic_actions>li {
      &>div.targets>ul>li {
        padding: 4px;
        img { width: auto; height: 28px; }
      }
    }
  }

  body.icon-zoom-2-00 {
    ul.actions>li, ul.special_actions>li, ul.heroic_actions>li {
      &>div.targets>ul>li {
        padding: 0;
        img { width: auto; height: 32px; }
      }
    }
  }

  .row > .cell.town-addons {
    flex-wrap: nowrap;
    & > .town-addon {
      flex-basis: 13%; width: 13%; height: auto; flex-shrink: 1;
      & > div { height: 0; width: 100%; padding-bottom: 100%; }
    }
  }
  .row > .cell.town-addons > .town-addon.town-addon-empty > div {
    height: 0;
    width: calc(100% - 4px);
    padding-bottom: 100%;
  }
  .dashboard .attack-estimation, .dashboard .def-estimation { border-right: none; }

  .soul .language-picker {
    flex-wrap: wrap;
    &>.note {
      width: 100%;
      flex-basis: 100%;
    }
  }

  #post-office-mobile-wrapper {
    &:not(.panel-2) {
      margin-left: 0;
      &>*:first-child { opacity: 1; }
      &>*:last-child  { opacity: 0; }
    }
    &.panel-2 {
      margin-left: -100%;
      &>*:first-child { opacity: 0; }
      &>*:last-child  { opacity: 1; }
    }
    &>*:first-child, &>*:last-child  { transition: opacity 0.20s ease-in-out }
    width: 200%; transition: margin-left 0.25s ease-in-out;
  }

  div[x-conditional-help="beyond_half_ap"] {
    position: fixed; top: 50px; left: 10px; right: 10px; width: auto;
    &:before {display: none}
  }

  .forum-preview-wrapper {
    .forum-preview-container { border: none; }

    &.forum-preview-wrapper-bank {
      min-height: max( 33vh, 120px );
      .forum-preview-container { position: unset; top: 0; left: 0; right: 0; bottom: 0; }
    }
  }

  .rucksack_status_union.status:before { background: url("../img/game-bar/cog2m.png") 0 0 no-repeat !important; }

  #beyond_chat { height: calc( 100% - 16px ); margin-top: 8px; margin-bottom: 8px; }
  div.beyond-escort-on:not(.beyond-escort-on-all)
  // ,div.beyond-escort-off
  {
    > div {
      border-right: 0 !important;
    }
  }
}

.postfix(@threshold, @postfix) {
  @media (max-width: (@threshold - 1)) {
    .row {
      >.cell{.grid(@myhordes-grid-columns,@postfix)}
      >.cell-small{.grid(@myhordes-grid-columns*2,@postfix)}
    }
    .row-flex {
      &.wrap-@{postfix} { flex-wrap: wrap !important; }
      &.wrap-inverse-@{postfix} { flex-wrap: wrap-reverse !important; }

      &>.cell, &>.cell-small { .flex-sizing(@myhordes-flex-size-max, @postfix); }
      >.cell {.flex-grid(@myhordes-flex-columns,@postfix)}
      >.cell-small {.flex-grid(@myhordes-flex-columns * 2,@postfix)}

      &.h-center-@{postfix} { justify-content: center; }
      &.left-@{postfix}     { justify-content: flex-start; }
      &.right-@{postfix}    { justify-content: flex-end; }
      &.v-center-@{postfix} { align-items: center; }
      &.top-@{postfix}      { align-items: flex-start; }
      &.bottom-@{postfix}   { align-items: flex-end; }
      &.stretch-@{postfix}  { align-items: stretch; }
    }

    .row, .row-flex {
      &>.cell,.cell-small {
        &.padded-@{postfix}       {padding: @myhordes-grid-padsize;}
        &.padded-small-@{postfix} {padding: @myhordes-grid-padsize-small;}
        &.padded-none-@{postfix}  {padding: 0}
      }
    }
  }
}

.postfix(@screen-extra-large-threshold, @screen-extra-large);

.postfix(@screen-large-threshold, @screen-large);
.postfix(@screen-medium-threshold, @screen-medium);
.postfix(@screen-small-threshold, @screen-small);